using System;
using System.Collections;

class CReceveur
{
	private long ValInterne =0;
	public long Val
	{
		get{return ValInterne;}
		set{ValInterne = value;}
	}
}
interface ICommand
{
	// TODO coder cette interface
};
class CAjou : ICommand
{
	// TODO coder cette classe
};
class CMult : ICommand
{
	// TODO coder cette classe

};
class CInvoker
{
	public void AddCommand( ICommand Command )
	{
		m_ListCommand.Add( Command );
	}
	public void ExecuteCommands()
	{
		// execute les commandes dans l'ordre 
		foreach( ICommand Command in m_ListCommand)
			Command.Execute();
	}
	public void UndoCommands()
	{
		// undo les commandes dans l'ordre inverse
		m_ListCommand.Reverse();
		foreach( ICommand Command in m_ListCommand)
			Command.Undo();
		m_ListCommand.Reverse();
	}
	private ArrayList m_ListCommand = new ArrayList();
};
class Prog
{
	// constantes 
	public static readonly long	JourSemaine = 3;
	public static readonly bool	bAnnivCetAnnee = true;
	public static readonly long	AnneeDeNaissance = 1975;
	public static void Main()
	{
		// construit la liste des commandes
		CReceveur	TheNumber = new CReceveur();
		CInvoker TheInvoker = new CInvoker();
		TheInvoker.AddCommand( new CMult( TheNumber ,2  ) );
		TheInvoker.AddCommand( new CAjou( TheNumber ,5  ) );
		TheInvoker.AddCommand( new CMult( TheNumber ,50 ) );
		TheInvoker.AddCommand( 
			new CAjou( TheNumber ,( bAnnivCetAnnee?1753:1752 )));
		TheInvoker.AddCommand( new CAjou( TheNumber ,-1975 ) );

		// excute puis undo les commandes
		TheNumber.Val = JourSemaine;
		Console.WriteLine("Dbut: {0}",TheNumber.Val);
		TheInvoker.ExecuteCommands();
		Console.WriteLine("Aprs excution: {0}",TheNumber.Val);
		TheInvoker.UndoCommands();
		Console.WriteLine("Aprs undo: {0}",TheNumber.Val);
	}
}
